
import dnd.models.Exit;
import dnd.models.Trap;
import java.util.ArrayList;

public class Door{

    private Exit exit;
    private boolean isTrapped;
    private boolean isOpen;
    private boolean isArchway;
    private Trap trap;
    private Space spaceone,spacetwo;
    private String description;

	public Door(){
		//needs to set defaults
	}
	public Door(Exit theExit){
		//sets up the door based on the Exit from the tables
        exit=theExit;
	}
	
	/******************************
	 Required Methods for that we will test during grading
	*******************************/
	/* note:  Some of these methods would normally be protected or private, but because we 
	don't want to dictate how you set up your packages we need them to be public 
	for the purposes of running an automated test suite (junit) on your code.  */

	public void setTrapped(boolean flag, int ... roll){
		// true == trapped.  Trap must be rolled if no integer is given
        if(flag==true){
            trap=new Trap();
            trap.setDescription(roll);
        }
	}
	public void setOpen(boolean flag){
		//true == open
        isOpen=flag;
	}

	public void setArchway(boolean flag){
		//true == is archway
        isArchway=flag;
	}

	public boolean isTrapped(){
		return isTrapped;
	}

	public boolean isOpen(){
		return isOpen;
	}

	public boolean isArchway(){
		return isArchway;
	}

	public String getTrapDescription(){
		if(trap==null){
            return null;
        }

        return trap.getDescription();

	}

	public ArrayList<Space> getSpaces(){
        ArrayList<Space> list=new ArrayList<Space>();
        list.add(spaceone);
        list.add(spacetwo);
		//returns the two spaces that are connected by the door
		return list;
	}
	public void setSpaces(Space spaceOne, Space spaceTwo){
		//identifies the two spaces with the door
		// this method should also call the addDoor method from Space
        spaceone=spaceOne;
        spacetwo=spaceTwo;
	}

	public String getDescription(){
		return description;
	}

    /***********
    You can write your own methods too, you aren't limited to the required ones
    *************/
}