

import dnd.models.Monster;
import dnd.models.Treasure;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;
/*
A passage begins at a door and ends at a door.  It may have many other doors along 
the way

You will need to keep track of which door is the "beginning" of the passage 
so that you know how to 
*/

public class Passage extends Space{
	//these instance variables are suggestions only
	//you can change them if you wish.
	
	private ArrayList<PassageSection> thePassage=new ArrayList<PassageSection>();
	private HashMap<Door,PassageSection> doorMap=new HashMap<Door,PassageSection>();
    private String description;

	/******************************
	 Required Methods for that we will test during grading
	*******************************/
	/* note:  Some of these methods would normally be protected or private, but because we 
	don't want to dictate how you set up your packages we need them to be public 
	for the purposes of running an automated test suite (junit) on your code.  */


    public ArrayList getDoors(){
        //gets all of the doors in the entire passage
        Set<Door> doors=doorMap.keySet();
        ArrayList<Door> result = new ArrayList<Door>(doors);
        return result;
    }

    public Door getDoor(int i){
        //returns the door in section 'i'. If there is no door, returns null
        int size=thePassage.size();
        if(i<0||i>size-1){
            return null;
        }
        PassageSection model=thePassage.get(i);

        for(Door key: doorMap.keySet()){
            if(doorMap.get(key).equals(model)){
                return key;
            }
        }

        return null;
    }

    public void addMonster(Monster theMonster, int i){
        // adds a monster to section 'i' of the passage
        thePassage.get(i).setMonster(theMonster);
    }

    public Monster getMonster(int i){
        //returns Monster door in section 'i'. If there is no Monster, returns null
        return thePassage.get(i).getMonster();
    }

    public void addPassageSection(PassageSection toAdd){
        //adds the passage section to the passageway
        thePassage.add(toAdd);
    }


    @Override
    public void setDoor(Door newDoor){
        //should add a door connection to the current Passage Section
        PassageSection model= thePassage.get(thePassage.size()-1);
        doorMap.put(newDoor,model);
    }

    @Override
    public String getDescription(){

        return description;
    }
    /***********
    You can write your own methods too, you aren't limited to the required ones
    *************/
}